"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileAttachment = void 0;
const inspectable_1 = require("inspectable");
const attachment_1 = require("./attachment");
/** Attachment with `fileId` and `fileUniqueId` properties */
let FileAttachment = class FileAttachment extends attachment_1.Attachment {
    constructor(payload) {
        super();
        this.payload = payload;
    }
    /** Identifier for this file, which can be used to download or reuse the file */
    get fileId() {
        return this.payload.file_id;
    }
    /**
     * Unique identifier for this file, which is supposed to be the same over
     * time and for different bots. Can't be used to download or reuse the file.
     */
    get fileUniqueId() {
        return this.payload.file_unique_id;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], FileAttachment.prototype, "fileId", null);
__decorate([
    (0, inspectable_1.Inspect)()
], FileAttachment.prototype, "fileUniqueId", null);
FileAttachment = __decorate([
    (0, inspectable_1.Inspectable)()
], FileAttachment);
exports.FileAttachment = FileAttachment;
