"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BotCommand = void 0;
const inspectable_1 = require("inspectable");
/** This object represents a bot command */
let BotCommand = class BotCommand {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Text of the command; 1-32 characters. Can contain only lowercase English letters, digits and underscores. */
    get command() {
        return this.payload.command;
    }
    /** Description of the command; 1-256 characters */
    get description() {
        return this.payload.description;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], BotCommand.prototype, "command", null);
__decorate([
    (0, inspectable_1.Inspect)()
], BotCommand.prototype, "description", null);
BotCommand = __decorate([
    (0, inspectable_1.Inspectable)()
], BotCommand);
exports.BotCommand = BotCommand;
