"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatBoostRemoved = void 0;
const inspectable_1 = require("inspectable");
const chat_1 = require("./chat");
const chat_boost_source_1 = require("./chat-boost-source");
/** This object represents a boost added to a chat or changed. */
let ChatBoostRemoved = class ChatBoostRemoved {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Chat which was boosted */
    get chat() {
        return new chat_1.Chat(this.payload.chat);
    }
    /** Unique identifier of the boost */
    get id() {
        return this.payload.boost_id;
    }
    /** Point in time (Unix timestamp) when the boost was removed */
    get removeDate() {
        return this.payload.remove_date;
    }
    /** Source of the removed boost */
    get source() {
        if (this.payload.source.source === 'premium') {
            return new chat_boost_source_1.ChatBoostSourcePremium(this.payload.source);
        }
        if (this.payload.source.source === 'gift_code') {
            return new chat_boost_source_1.ChatBoostSourceGiftCode(this.payload.source);
        }
        if (this.payload.source.source === 'giveaway') {
            return new chat_boost_source_1.ChatBoostSourceGiveaway(this.payload.source);
        }
        throw new TypeError('unknown chat boost source');
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostRemoved.prototype, "chat", null);
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostRemoved.prototype, "id", null);
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostRemoved.prototype, "removeDate", null);
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostRemoved.prototype, "source", null);
ChatBoostRemoved = __decorate([
    (0, inspectable_1.Inspectable)()
], ChatBoostRemoved);
exports.ChatBoostRemoved = ChatBoostRemoved;
