"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatBoostSourceGiveaway = void 0;
const inspectable_1 = require("inspectable");
const user_1 = require("../user");
const chat_boost_source_1 = require("./chat-boost-source");
/** The boost was obtained by the creation of a Telegram Premium giveaway. This boosts the chat 4 times for the duration of the corresponding Telegram Premium subscription. */
let ChatBoostSourceGiveaway = class ChatBoostSourceGiveaway extends chat_boost_source_1.ChatBoostSource {
    constructor(payload) {
        super(payload);
        this.payload = payload;
    }
    /** Source of the boost, always `giveaway` */
    get source() {
        return this.payload.source;
    }
    get giveawayMessageId() {
        return this.payload.giveaway_message_id;
    }
    /** User that boosted the chat */
    get user() {
        const { user } = this.payload;
        if (!user) {
            return;
        }
        return new user_1.User(user);
    }
    /** `true`, if the giveaway was completed, but there was no user to win the prize */
    isUnclaimed() {
        return this.payload.is_unclaimed;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostSourceGiveaway.prototype, "source", null);
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], ChatBoostSourceGiveaway.prototype, "user", null);
__decorate([
    (0, inspectable_1.Inspect)({ compute: true, nullable: false })
], ChatBoostSourceGiveaway.prototype, "isUnclaimed", null);
ChatBoostSourceGiveaway = __decorate([
    (0, inspectable_1.Inspectable)()
], ChatBoostSourceGiveaway);
exports.ChatBoostSourceGiveaway = ChatBoostSourceGiveaway;
