"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatBoostSourcePremium = void 0;
const inspectable_1 = require("inspectable");
const user_1 = require("../user");
const chat_boost_source_1 = require("./chat-boost-source");
/** The boost was obtained by subscribing to Telegram Premium or by gifting a Telegram Premium subscription to another user. */
let ChatBoostSourcePremium = class ChatBoostSourcePremium extends chat_boost_source_1.ChatBoostSource {
    constructor(payload) {
        super(payload);
        this.payload = payload;
    }
    /** Source of the boost, always `premium` */
    get source() {
        return this.payload.source;
    }
    /** User that boosted the chat */
    get user() {
        return new user_1.User(this.payload.user);
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostSourcePremium.prototype, "source", null);
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostSourcePremium.prototype, "user", null);
ChatBoostSourcePremium = __decorate([
    (0, inspectable_1.Inspectable)()
], ChatBoostSourcePremium);
exports.ChatBoostSourcePremium = ChatBoostSourcePremium;
