"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatBoostUpdated = void 0;
const inspectable_1 = require("inspectable");
const chat_1 = require("./chat");
const chat_boost_1 = require("./chat-boost");
/** This object represents a boost added to a chat or changed. */
let ChatBoostUpdated = class ChatBoostUpdated {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Chat which was boosted */
    get chat() {
        return new chat_1.Chat(this.payload.chat);
    }
    /** Infomation about the chat boost */
    get boost() {
        return new chat_boost_1.ChatBoost(this.payload.boost);
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostUpdated.prototype, "chat", null);
__decorate([
    (0, inspectable_1.Inspect)()
], ChatBoostUpdated.prototype, "boost", null);
ChatBoostUpdated = __decorate([
    (0, inspectable_1.Inspectable)()
], ChatBoostUpdated);
exports.ChatBoostUpdated = ChatBoostUpdated;
