"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dice = void 0;
const inspectable_1 = require("inspectable");
/** This object represents an animated emoji that displays a random value. */
let Dice = class Dice {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Emoji on which the dice throw animation is based */
    get emoji() {
        return this.payload.emoji;
    }
    /**
     * Value of the dice,
     * `1-6` for `🎲`, `🎯` and `🎳` base emoji,
     * `1-5` for `🏀` and `⚽️` base emoji,
     * `1-64` for `🎰` base emoji
     */
    get value() {
        return this.payload.value;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], Dice.prototype, "emoji", null);
__decorate([
    (0, inspectable_1.Inspect)()
], Dice.prototype, "value", null);
Dice = __decorate([
    (0, inspectable_1.Inspectable)()
], Dice);
exports.Dice = Dice;
