"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForumTopicEdited = void 0;
const inspectable_1 = require("inspectable");
/** This object represents a service message about an edited forum topic. */
let ForumTopicEdited = class ForumTopicEdited {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** New name of the topic, if it was edited */
    get name() {
        return this.payload.name;
    }
    /** New identifier of the custom emoji shown as the topic icon, if it was edited; an empty string if the icon was removed */
    get iconCustomEmojiId() {
        return this.payload.icon_custom_emoji_id;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], ForumTopicEdited.prototype, "name", null);
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], ForumTopicEdited.prototype, "iconCustomEmojiId", null);
ForumTopicEdited = __decorate([
    (0, inspectable_1.Inspectable)()
], ForumTopicEdited);
exports.ForumTopicEdited = ForumTopicEdited;
