"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GiveawayCompleted = void 0;
const inspectable_1 = require("inspectable");
const message_1 = require("./message");
/** This object represents a service message about the completion of a giveaway without public winners. */
let GiveawayCompleted = class GiveawayCompleted {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Number of winners in the giveaway */
    get winnerCount() {
        return this.payload.winner_count;
    }
    /** Number of undistributed prizes */
    get unclaimedPrizeCount() {
        return this.payload.unclaimed_prize_count;
    }
    /** Message with the giveaway that was completed, if it wasn't deleted */
    get message() {
        const { giveaway_message } = this.payload;
        if (!giveaway_message) {
            return;
        }
        return new message_1.Message(giveaway_message);
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], GiveawayCompleted.prototype, "winnerCount", null);
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], GiveawayCompleted.prototype, "unclaimedPrizeCount", null);
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], GiveawayCompleted.prototype, "message", null);
GiveawayCompleted = __decorate([
    (0, inspectable_1.Inspectable)()
], GiveawayCompleted);
exports.GiveawayCompleted = GiveawayCompleted;
