"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InaccessibleMessage = void 0;
const inspectable_1 = require("inspectable");
const chat_1 = require("./chat");
let InaccessibleMessage = class InaccessibleMessage {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Unique message identifier inside the chat */
    get id() {
        return this.payload.message_id;
    }
    /** Chat the message belonged to */
    get chat() {
        return new chat_1.Chat(this.payload.chat);
    }
    /** Always `0`. The field can be used to differentiate regular and inaccessible messages. */
    get date() {
        return this.payload.date;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], InaccessibleMessage.prototype, "id", null);
__decorate([
    (0, inspectable_1.Inspect)()
], InaccessibleMessage.prototype, "chat", null);
__decorate([
    (0, inspectable_1.Inspect)()
], InaccessibleMessage.prototype, "date", null);
InaccessibleMessage = __decorate([
    (0, inspectable_1.Inspectable)()
], InaccessibleMessage);
exports.InaccessibleMessage = InaccessibleMessage;
