"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InlineKeyboardMarkup = void 0;
const inspectable_1 = require("inspectable");
const inline_keyboard_button_1 = require("./inline-keyboard-button");
/** This object represents an inline keyboard that appears right next to the message it belongs to. */
let InlineKeyboardMarkup = class InlineKeyboardMarkup {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Array of button rows */
    get inlineKeyboard() {
        const { inline_keyboard } = this.payload;
        return inline_keyboard.map(row => row.map(element => new inline_keyboard_button_1.InlineKeyboardButton(element)));
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], InlineKeyboardMarkup.prototype, "inlineKeyboard", null);
InlineKeyboardMarkup = __decorate([
    (0, inspectable_1.Inspectable)()
], InlineKeyboardMarkup);
exports.InlineKeyboardMarkup = InlineKeyboardMarkup;
