"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkPreviewOptions = void 0;
const inspectable_1 = require("inspectable");
/** Describes the options used for link preview generation. */
let LinkPreviewOptions = class LinkPreviewOptions {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** `true`, if the link preview is disabled */
    isDisabled() {
        return this.payload.is_disabled;
    }
    /** URL to use for the link preview. If empty, then the first URL found in the message text will be used */
    get url() {
        return this.payload.url;
    }
    /** `true`, if the media in the link preview is supposed to be shrunk; ignored if the URL isn't explicitly specified or media size change isn't supported for the preview */
    preferSmallMedia() {
        return this.payload.prefer_small_media;
    }
    /** `true`, if the media in the link preview is supposed to be enlarged; ignored if the URL isn't explicitly specified or media size change isn't supported for the preview */
    preferLargeMedia() {
        return this.payload.prefer_large_media;
    }
    /** `true`, if the link preview must be shown above the message text; otherwise, the link preview will be shown below the message text */
    showAboveText() {
        return this.payload.show_above_text;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)({ compute: true, nullable: false })
], LinkPreviewOptions.prototype, "isDisabled", null);
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], LinkPreviewOptions.prototype, "url", null);
__decorate([
    (0, inspectable_1.Inspect)({ compute: true, nullable: false })
], LinkPreviewOptions.prototype, "preferSmallMedia", null);
__decorate([
    (0, inspectable_1.Inspect)({ compute: true, nullable: false })
], LinkPreviewOptions.prototype, "preferLargeMedia", null);
__decorate([
    (0, inspectable_1.Inspect)({ compute: true, nullable: false })
], LinkPreviewOptions.prototype, "showAboveText", null);
LinkPreviewOptions = __decorate([
    (0, inspectable_1.Inspectable)()
], LinkPreviewOptions);
exports.LinkPreviewOptions = LinkPreviewOptions;
