"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageOriginChannel = void 0;
const inspectable_1 = require("inspectable");
const chat_1 = require("../chat");
const message_origin_1 = require("./message-origin");
/** The message was originally sent to a channel chat. */
let MessageOriginChannel = class MessageOriginChannel extends message_origin_1.MessageOrigin {
    constructor(payload) {
        super(payload);
        this.payload = payload;
    }
    /** Type of the message origin, always `channel` */
    get type() {
        return this.payload.type;
    }
    /** Date the message was sent originally in Unix time */
    get date() {
        return this.payload.date;
    }
    /** Channel chat to which the message was originally sent */
    get chat() {
        return new chat_1.Chat(this.payload.chat);
    }
    /** Unique message identifier inside the chat */
    get messageId() {
        return this.payload.message_id;
    }
    /** Signature of the original post author */
    get authorSignature() {
        return this.payload.author_signature;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginChannel.prototype, "type", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginChannel.prototype, "date", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginChannel.prototype, "chat", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginChannel.prototype, "messageId", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginChannel.prototype, "authorSignature", null);
MessageOriginChannel = __decorate([
    (0, inspectable_1.Inspectable)()
], MessageOriginChannel);
exports.MessageOriginChannel = MessageOriginChannel;
