"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageOriginChat = void 0;
const inspectable_1 = require("inspectable");
const chat_1 = require("../chat");
const message_origin_1 = require("./message-origin");
/** The message was originally sent on behalf of a chat to a group chat. */
let MessageOriginChat = class MessageOriginChat extends message_origin_1.MessageOrigin {
    constructor(payload) {
        super(payload);
        this.payload = payload;
    }
    /** Type of the message origin, always `chat` */
    get type() {
        return this.payload.type;
    }
    /** Date the message was sent originally in Unix time */
    get date() {
        return this.payload.date;
    }
    /** Chat that sent the message originally */
    get senderChat() {
        return new chat_1.Chat(this.payload.sender_chat);
    }
    /** For messages originally sent by an anonymous chat administrator, original message author signature */
    get authorSignature() {
        return this.payload.author_signature;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginChat.prototype, "type", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginChat.prototype, "date", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginChat.prototype, "senderChat", null);
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], MessageOriginChat.prototype, "authorSignature", null);
MessageOriginChat = __decorate([
    (0, inspectable_1.Inspectable)()
], MessageOriginChat);
exports.MessageOriginChat = MessageOriginChat;
