"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageOriginHiddenUser = void 0;
const inspectable_1 = require("inspectable");
const message_origin_1 = require("./message-origin");
/** The message was originally sent by an unknown user. */
let MessageOriginHiddenUser = class MessageOriginHiddenUser extends message_origin_1.MessageOrigin {
    constructor(payload) {
        super(payload);
        this.payload = payload;
    }
    /** Type of the message origin, always `hidden_user` */
    get type() {
        return this.payload.type;
    }
    /** Date the message was sent originally in Unix time */
    get date() {
        return this.payload.date;
    }
    /** Name of the user that sent the message originally */
    get senderUserName() {
        return this.payload.sender_user_name;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginHiddenUser.prototype, "type", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginHiddenUser.prototype, "date", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginHiddenUser.prototype, "senderUserName", null);
MessageOriginHiddenUser = __decorate([
    (0, inspectable_1.Inspectable)()
], MessageOriginHiddenUser);
exports.MessageOriginHiddenUser = MessageOriginHiddenUser;
