"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageOriginUser = void 0;
const inspectable_1 = require("inspectable");
const user_1 = require("../user");
const message_origin_1 = require("./message-origin");
/** The message was originally sent by a known user. */
let MessageOriginUser = class MessageOriginUser extends message_origin_1.MessageOrigin {
    constructor(payload) {
        super(payload);
        this.payload = payload;
    }
    /** Type of the message origin, always `user` */
    get type() {
        return this.payload.type;
    }
    /** Date the message was sent originally in Unix time */
    get date() {
        return this.payload.date;
    }
    /** User that sent the message originally */
    get senderUser() {
        return new user_1.User(this.payload.sender_user);
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginUser.prototype, "type", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginUser.prototype, "date", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageOriginUser.prototype, "senderUser", null);
MessageOriginUser = __decorate([
    (0, inspectable_1.Inspectable)()
], MessageOriginUser);
exports.MessageOriginUser = MessageOriginUser;
