"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageReactionCountUpdated = void 0;
const inspectable_1 = require("inspectable");
const chat_1 = require("./chat");
const reaction_type_1 = require("./reaction-type");
/** This object represents reaction changes on a message with anonymous reactions. */
let MessageReactionCountUpdated = class MessageReactionCountUpdated {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** The chat containing the message the user reacted to */
    get chat() {
        return new chat_1.Chat(this.payload.chat);
    }
    /** Unique identifier of the message inside the chat */
    get id() {
        return this.payload.message_id;
    }
    /** Date of the change in Unix time */
    get date() {
        return this.payload.date;
    }
    /** List of reactions that are present on the message */
    get reactions() {
        const reactions = [];
        for (const reaction of this.payload.reactions) {
            if (reaction.type.type === 'emoji') {
                reactions.push(new reaction_type_1.ReactionTypeEmoji(reaction.type));
            }
            else if (reaction.type.type === 'custom_emoji') {
                reactions.push(new reaction_type_1.ReactionTypeCustomEmoji(reaction.type));
            }
            else {
                throw new TypeError('unknown reaction type');
            }
        }
        return reactions;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], MessageReactionCountUpdated.prototype, "chat", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageReactionCountUpdated.prototype, "id", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageReactionCountUpdated.prototype, "date", null);
__decorate([
    (0, inspectable_1.Inspect)()
], MessageReactionCountUpdated.prototype, "reactions", null);
MessageReactionCountUpdated = __decorate([
    (0, inspectable_1.Inspectable)()
], MessageReactionCountUpdated);
exports.MessageReactionCountUpdated = MessageReactionCountUpdated;
