"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PollOption = void 0;
const inspectable_1 = require("inspectable");
/** This object contains information about one answer option in a poll. */
let PollOption = class PollOption {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Option text, 1-100 characters */
    get text() {
        return this.payload.text;
    }
    /** Number of users that voted for this option */
    get voterCount() {
        return this.payload.voter_count;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], PollOption.prototype, "text", null);
__decorate([
    (0, inspectable_1.Inspect)()
], PollOption.prototype, "voterCount", null);
PollOption = __decorate([
    (0, inspectable_1.Inspectable)()
], PollOption);
exports.PollOption = PollOption;
