"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactionCount = void 0;
const inspectable_1 = require("inspectable");
const reaction_type_1 = require("./reaction-type");
/** Represents a reaction added to a message along with the number of times it was added. */
let ReactionCount = class ReactionCount {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Type of the reaction */
    get type() {
        if (this.payload.type.type === 'emoji') {
            return new reaction_type_1.ReactionTypeEmoji(this.payload.type);
        }
        if (this.payload.type.type === 'custom_emoji') {
            return new reaction_type_1.ReactionTypeCustomEmoji(this.payload.type);
        }
        throw new TypeError('unknown reaction type');
    }
    /** Number of times the reaction was added */
    get totalCount() {
        return this.payload.total_count;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], ReactionCount.prototype, "type", null);
__decorate([
    (0, inspectable_1.Inspect)()
], ReactionCount.prototype, "totalCount", null);
ReactionCount = __decorate([
    (0, inspectable_1.Inspectable)()
], ReactionCount);
exports.ReactionCount = ReactionCount;
