"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SentWebAppMessage = void 0;
const inspectable_1 = require("inspectable");
/** Contains information about an inline message sent by a Web App on behalf of a user. */
let SentWebAppMessage = class SentWebAppMessage {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /**
     * Identifier of the sent inline message.
     *
     * Available only if there is an inline keyboard attached to the message.
     */
    get inlineMessageId() {
        return this.payload.inline_message_id;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], SentWebAppMessage.prototype, "inlineMessageId", null);
SentWebAppMessage = __decorate([
    (0, inspectable_1.Inspectable)()
], SentWebAppMessage);
exports.SentWebAppMessage = SentWebAppMessage;
