"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsersShared = void 0;
const inspectable_1 = require("inspectable");
/** This object contains information about the user whose identifier was shared with the bot using a `KeyboardButtonRequestUser` button. */
let UsersShared = class UsersShared {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** Identifier of the request */
    get requestId() {
        return this.payload.request_id;
    }
    /** Identifier of the shared user. This number may have more than 32 significant bits and some programming languages may have difficulty/silent defects in interpreting it. But it has at most 52 significant bits, so a 64-bit integer or double-precision float type are safe for storing this identifier. The bot may not have access to the user and could be unable to use this identifier, unless the user is already known to the bot by some other means. */
    get userIds() {
        return this.payload.user_ids;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], UsersShared.prototype, "requestId", null);
__decorate([
    (0, inspectable_1.Inspect)()
], UsersShared.prototype, "userIds", null);
UsersShared = __decorate([
    (0, inspectable_1.Inspectable)()
], UsersShared);
exports.UsersShared = UsersShared;
