"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebAppData = void 0;
const inspectable_1 = require("inspectable");
/** Contains data sent from a Web App to the bot. */
let WebAppData = class WebAppData {
    constructor(payload) {
        this.payload = payload;
    }
    /** The data. Be aware that a bad client can send arbitrary data in this field. */
    get data() {
        return this.payload.data;
    }
    /**
     * Text of the `web_app` keyboard button, from which the Web App was opened.
     * Be aware that a bad client can send arbitrary data in this field.
     */
    get buttonText() {
        return this.payload.button_text;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)()
], WebAppData.prototype, "data", null);
__decorate([
    (0, inspectable_1.Inspect)()
], WebAppData.prototype, "buttonText", null);
WebAppData = __decorate([
    (0, inspectable_1.Inspectable)()
], WebAppData);
exports.WebAppData = WebAppData;
