"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WriteAccessAllowed = void 0;
const inspectable_1 = require("inspectable");
/** This object represents a service message about a user allowing a bot added to the attachment menu to write messages. Currently holds no information. */
let WriteAccessAllowed = class WriteAccessAllowed {
    constructor(payload) {
        this.payload = payload;
    }
    get [Symbol.toStringTag]() {
        return this.constructor.name;
    }
    /** `true`, if the access was granted after the user accepted an explicit request from a Web App sent by the method requestWriteAccess */
    get fromRequest() {
        return this.payload.from_request;
    }
    /** Name of the Web App which was launched from a link */
    get webAppName() {
        return this.payload.web_app_name;
    }
    /** `true`, if the access was granted when the bot was added to the attachment or side menu */
    get fromAttachmentMenu() {
        return this.payload.web_app_name;
    }
    toJSON() {
        return this.payload;
    }
};
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], WriteAccessAllowed.prototype, "fromRequest", null);
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], WriteAccessAllowed.prototype, "webAppName", null);
__decorate([
    (0, inspectable_1.Inspect)({ nullable: false })
], WriteAccessAllowed.prototype, "fromAttachmentMenu", null);
WriteAccessAllowed = __decorate([
    (0, inspectable_1.Inspectable)()
], WriteAccessAllowed);
exports.WriteAccessAllowed = WriteAccessAllowed;
